local M = {}

M.load = function()
  -- офф. загрузка lazy если что см. их доки https://github.com/folke/lazy.nvim
  local lazypath = vim.fn.stdpath("data") .. "/lazy/lazy.nvim"
  if not vim.loop.fs_stat(lazypath) then
    vim.fn.system({
      "git", "clone", "--filter=blob:none",
      "https://github.com/folke/lazy.nvim.git", "--branch=stable", -- latest stable release
      lazypath
    })
  end
  vim.opt.rtp:prepend(lazypath)

  require("lazy").setup(
    {
      { import = "plugins.configs" },
      { import = "plugins.configs.lsp" }
    },
    {
      install = {
        colorscheme = { "catppuccin" }
      },
      checker = {
        enabled = false, -- проверка обновления
        notify = false -- уведомление об обновлении
      },
      change_detection = {
        notify = false -- уведомление если файл изменили
      }
    }
  )
end

return M

-- опробовать
-- https://github.com/aznhe21/actions-preview.nvim
